<?php
namespace Pinpoint\Feed\Cron;

use Magento\Store\Model\StoreManagerInterface;
use Pinpoint\Feed\Model\BlogFeed;
use Psr\Log\LoggerInterface;

/**
 * Class BlogFeedCron
 * @package Pinpoint\Feed\Cron
 */
class BlogFeedCron
{
    /**
     * @var BlogFeed
     */
    protected $blogFeed;

    /**
     * @var LoggerInterface
     */
    protected $logger;

    /**
     * @var StoreManagerInterface
     */
    protected $storeManager;

    /**
     * BlogFeedCron constructor.
     * @param BlogFeed $blogFeed
     * @param LoggerInterface $logger
     * @param StoreManagerInterface $storeManager
     */
    public function __construct(BlogFeed $blogFeed, LoggerInterface $logger, StoreManagerInterface $storeManager)
    {
        $this->blogFeed = $blogFeed;
        $this->logger = $logger;
        $this->storeManager = $storeManager;
    }

    /**
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function execute()
    {
        $stores = $this->storeManager->getStores();

        foreach ($stores as $store) {
            $this->logger->info('Blog Feed Cron Running for ' . $store->getName());
            $this->blogFeed->setStore($store);
            $this->blogFeed->generateXml();
            $this->logger->info('Blog Feed Cron Completed for ' . $store->getName());
        }
    }
}