<?php
namespace Pinpoint\Feed\Cron;
use Magento\Store\Model\StoreManagerInterface;
use Pinpoint\Feed\Model\PageCmsFeed;
use Psr\Log\LoggerInterface;

/**
 * Class PageFeedCron
 * @package Pinpoint\Feed\Cron
 */
class PageFeedCron
{
    /**
     * @var PageCmsFeed
     */
    protected $pageCmsFeed;
    /**
     * @var LoggerInterface
     */
    protected $logger;


    /**
     * @var StoreManagerInterface
     */
    protected $storeManager;

    /**
     * PageFeedCron constructor.
     * @param PageCmsFeed $pageCmsFeed
     * @param LoggerInterface $logger
     * @param StoreManagerInterface $storeManager
     */
    public function __construct(PageCmsFeed $pageCmsFeed, LoggerInterface $logger, StoreManagerInterface $storeManager)
    {
        $this->pageCmsFeed = $pageCmsFeed;
        $this->logger = $logger;
        $this->storeManager = $storeManager;
    }

    /**
     * @throws \Magento\Framework\Exception\FileSystemException
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function execute()
    {
        $stores = $this->storeManager->getStores();

        foreach ($stores as $store) {
            $this->logger->info('Page Feed Cron Running for ' . $store->getName());
            $this->pageCmsFeed->setStore($store);
            $this->pageCmsFeed->generateXml();
            $this->logger->info('Page Feed Cron Completed for ' . $store->getName());
        }
    }
}